#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mount.h>
#include <linux/sched.h>
#include <err.h>

int main()
{
        int ret;
        ret = unshare(CLONE_NEWNS);
        if (ret)
                err(1, "unshare");
        int oldroot, newroot;

	ret = mount("none", "/", NULL, MS_REC | MS_PRIVATE, NULL);
	if (ret)
		err(1, "mount MS_PRIVATE");

        ret = mount("/", "/mnt", "none", MS_BIND | MS_REC, NULL);
        if (ret)
                err(1, "mount");

        oldroot = open("/", O_DIRECTORY | O_RDONLY);
        if (oldroot < 0)
		err(1, "open /");
        newroot = open("/mnt", O_DIRECTORY | O_RDONLY);
        if (newroot < 0)
                err(1, "open /mnt");
        if (fchdir(newroot))
                err(1, "fchdir(newroot) before pivot_root");

        if (pivot_root(".", "."))
                err(1, "pivot_root");
        printf("pivoted\n");

        if (fchdir(oldroot) < 0)
		err(1, "fchdir(oldroot)");
        if (umount2("/", MNT_DETACH) < 0)
		err(1, "umount2");
        if (fchdir(newroot) < 0)
                err(1, "fchdir(newroot");
        printf("in new root\n");
        close(oldroot);
        close(newroot);
        printf("I am %d\n", getpid());
        execl("/bin/bash", "/bin/bash", NULL);
}
